/
The purpose of this script is to perform a kind of filter on a table.
We only want to select those rows if they match one of the rows of the conditions table 
The complexity comes from the requirement that if there is a null in a column x of a condition row,then we don't filter
on that column. i.e nulls behave like wildcards 

Without this wildcard requirement, the solution is trival (in function)
eg: res:data_tbl where(select cond1,cond2 from data_tbl)in conditions

\

/Perform a filter on the rows of data_tbl
data_tbl:([]cond1:1 1 2 2;cond2:1 2 1 2;other:10 20 30 40);

/A row from data_tbl is selected if it meets either of these condition rows
/Note:For 2nd condition row, only condition is cond1=2 because null is a wildcard
conditions:([]cond1:1 2;cond2:1 0N);

/The desired result is the following subset of tbl:
desired:([]cond1:1 2 2;cond2:1 1 2;other:10 30 40);

/Approach 1
/
Slower Atomic Approach

3 inputs: data_tbl, conditions_tbl and condition_cols
The idea is to create a cross product between the data rows and the condition rows and pass each
combination of these two sets into a lamda to check if they match. 
If the last condition value is null, then only check the first condition
Otherwise, check both conditions

\
cmp1:{[x;y;z]
	B:
		{[x;y]$[null y 1;x[0]=y 0;all x=y]}\:/:
		[flip[x z];flip y z];
		res:x where (|/) B;
		:res;
	};


show res1:cmp1[data_tbl;conditions;`cond1`cond2];

/Approach 2
/
Faster Vector Approach
3 inputs: data_tbl, conditions_tbl and condition_cols
We write a dyadic lamda that takes 2 inputs. The first input is fixed to be the data_tbl
For the second input, we will loop over each condition row
So, each iternation of the lamda checks which data rows match a given condition
\
cmp2:{[x;y;z]
			B:
			{[x;y]all null[y]|y=x}/:
				[(x z);flip y z];
			res:x where (|/) B;
			:res;
		};

show res2:cmp2[data_tbl;conditions;`cond1`cond2];

show res1~res2;

/
show"performance test";
n:100000
cond1s:til 100
cond2s:(5#`),-95?`3
cond2s:-100?`3

conditions:([]cond1:cond1s;cond2:cond2s);
data_tbl:([]cond1:n?cond1s;cond2:n?cond2s;other:n?10);

\ts do[1;res1:cmp1[data_tbl;conditions;`cond1`cond2]]
\ts do[1;res2:cmp2[data_tbl;conditions;`cond1`cond2]]
show res1~res2;




